from zoodb import *
from debug import *
import base64
import pbkdf2
import hashlib
import random
import bank
import pspy

def newtoken(db, person):
    hashinput = "%s%.10f" % (person.password, random.random())
    person.token = hashlib.md5(hashinput).hexdigest()
    db.commit()
    return person.token


@pspy.service(group="AuthGroup", perms={'zoobar/db/cred/': 0700}, service_provider="Auth")
def login(username, password):
    db = cred_setup()
    person = db.query(Cred).get(username)
    if not person:
        return None
    if person.password == pbkdf2.PBKDF2(password, person.salt).hexread(32):
        return newtoken(db, person)
    else:
        return None


@pspy.service(service_provider="Auth")
def register(username, password):
    bank.register(username)
    db = cred_setup()
    person = db.query(Cred).get(username)
    if person:
        return None
    newperson = Cred()
    newperson.username = username
    salt = base64.b64encode(os.urandom(128))
    newperson.salt = salt
    newperson.password = pbkdf2.PBKDF2(password, salt).hexread(32)
    db.add(newperson)
    db.commit()
    db1 = person_setup()
    person1 = db1.query(Person).get(username)
    if person1:
        return None
    newperson1 = Person()
    newperson1.username = username
    db1.add(newperson1)
    db1.commit()

    return newtoken(db, newperson)


@pspy.service(service_provider="Auth")
def check_token(username, token):
    db = cred_setup()
    person = db.query(Cred).get(username)
    if person and person.token == token:
        return True
    else:
        return False
