from zoodb import *
from debug import *
import auth
import time
import pspy


@pspy.service(group="BankGroup", perms={"zoobar/db/bank/": 0700}, service_provider="Bank")
def transfer(sender, recipient, zoobars, token):
    bankdb = bank_setup()
    senderp = bankdb.query(Bank).get(sender)
    recipientp = bankdb.query(Bank).get(recipient)

    sender_balance = senderp.zoobars - zoobars
    recipient_balance = recipientp.zoobars + zoobars
    if not auth.check_token(sender, token):
        raise ValueError()
    if zoobars <= 0:
       raise ValueError()
    if sender == recipient:
       raise ValueError()
    if sender_balance < 0 or recipient_balance < 0:
        raise ValueError()

    senderp.zoobars = sender_balance
    recipientp.zoobars = recipient_balance
    bankdb.commit()

    transfer = Transfer()
    transfer.sender = sender
    transfer.recipient = recipient
    transfer.amount = zoobars
    transfer.time = time.asctime()

    transferdb = transfer_setup()
    transferdb.add(transfer)
    transferdb.commit()


@pspy.service(service_provider="Bank")
def balance(username):
    db = bank_setup()
    person = db.query(Bank).get(username)
    return person.zoobars

def get_log(username):
    db = transfer_setup()
    return db.query(Transfer).filter(or_(Transfer.sender==username,
                                         Transfer.recipient==username))


@pspy.service(service_provider="Bank")
def register(username):
    db = bank_setup()
    newperson = Bank()
    newperson.username = username
    db.add(newperson)
    db.commit()
